<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />

  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css" integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">

  <meta name="keywords" content="zonal stats, spei, raster, gadm" />
  <title>Comparative Accuracy and Processing Time for Zonal Statistic Methodologies</title>
  <style>
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>

  <style>
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(data-line-number);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>

  <link rel="stylesheet" href="/usr/local/lib/R/site-library/danteSubmit/rmarkdown/templates/dante_vignette/resources/style.css" />

  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
  <script src="exact_extract_comp_files/kePrint-0.0.1/kePrint.js"></script>
</head>

<body>

<header id="title-block-header">
<h1 class="title">Comparative Accuracy and Processing Time for Zonal Statistic Methodologies</h1>

<p class="date" id="date"><em>2019-09-09</em></p>

<div id="author-block">
<span id="author-name">Joshua Brinks</span>,&nbsp;<span id="author-affiliation"><em>ISciences, L.L.C.</em>&nbsp;<sup><a id="author-email" href="mailto:jbrinks@isciences.com"><i class="far fa-envelope" style="font-size:15px; color: blue"></i></a></sup></br>
<span id="author-name">Dan Baston</span>,&nbsp;<span id="author-affiliation"><em>ISciences, L.L.C.</em>&nbsp;<sup><a id="author-email" href="mailto:dbaston@isciences.com"><i class="far fa-envelope" style="font-size:15px; color: blue"></i></a></sup></br>
</div>

<div id="vignette-highlights-block">
<h3> Highlights: </h3>
<ul>
<li>exactextractr greatly reduces processing time over widely used zonal statistics tools.</li>
<li>Gains in processing times were 3-4 times that of velox, and up to 160 times the raster package.</li>
<li>Differences in zonal statistic estimates averaged 4-5%, but climbed to 20% and beyond in several instances.</li>
</ul>
</div>


<div id="keywords-block">
<span style="color: #633CA3; font-size:1.4em; font-weight: bold;"> Keywords:</span>
<span id="keywords">zonal stats, spei, raster, gadm</span>
</div>

</header>

<h3> Contents: </h3>
<nav id="TOC" role="doc-toc">
<ul>
<li><a href="#introduction"><span class="toc-section-number">1</span> Introduction</a><ul>
<li><a href="#background"><span class="toc-section-number">1.1</span> Background</a></li>
</ul></li>
<li><a href="#methods"><span class="toc-section-number">2</span> Methods</a><ul>
<li><a href="#loading-the-packages"><span class="toc-section-number">2.1</span> Loading the Packages</a></li>
<li><a href="#getting-the-data"><span class="toc-section-number">2.2</span> Getting the Data</a></li>
<li><a href="#the-extractions"><span class="toc-section-number">2.3</span> The Extractions</a></li>
<li><a href="#increasing-the-variance"><span class="toc-section-number">2.4</span> Increasing the Variance</a></li>
</ul></li>
<li><a href="#conclusions"><span class="toc-section-number">3</span> Conclusions</a></li>
<li><a href="#references">References</a></li>
</ul>
</nav>

<div id="introduction" class="section level1">
<h1><span class="header-section-number">1</span> Introduction</h1>
<div id="background" class="section level2">
<h2><span class="header-section-number">1.1</span> Background</h2>
<p>Zonal statistics are a key process to many exploratory analyses, peer reviewed research, and data science production pipelines. Recently, they have been featured in research of meta-analyses of ecological field studies <span class="citation">(Martin, Blossey, and Ellis <a href="#ref-Martin2012b">2012</a>)</span>, land use cover classification <span class="citation">(Saadat et al. <a href="#ref-Saadat2011">2011</a>)</span>, estimating the cost of anthropogenic nitrogen pollution <span class="citation">(Sobota et al. <a href="#ref-Sobota2015">2015</a>)</span>, and conservation planning <span class="citation">(Segan et al. <a href="#ref-Segan2011">2011</a>)</span>. They are used to summarize a variety of spatial data using only raster data, or a combination of raster and vector data. As a raster to raster process, zonal stats are fairly straight-forward; after preparing the raster layers in matching resolutions, overlapping cells are summarized with the specified function. As a vector to raster operation, there are greater considerations.</p>
<p>I was introduced to zonal statistics through the ESRI’s ArcView 3.1, and over the course of 10-15 years I sparingly used sum, mean, and max zonal statistics functions with ArcView, ArcGIS Desktop, and QGIS for a variety of lab assignments, graduate research, and a few professional projects. However, last year I was tasked with a large project investigating global agricultural supply chains that shattered my pre-conceived notions of zonal statistics. At first, I was alarmed by the processing time given a production environment for zonal sums using global layers of HydroBASINS vector watershed sub-basins <span class="citation">(Lehner and Grill <a href="#ref-Lehner2013">2013</a>)</span> and International Food Policy Research Institute’s MapSPAM raster layers of agricultural production <span class="citation">(IFPRI <a href="#ref-IFPRI2019">2019</a>)</span>. Summing crop values for tens of thousands of watersheds tool several hours, and in many cases simply crashed the process after 8-10 hours, while using enterprise grade in-house server hardware. After experimenting with a variety of R packages, standalone software, and pre-processing solutions like simplifying vector features, I was horrified by the comparative results; in some cases the crop sums differed by orders of magnitude when aggregated from sub-basins back into larger watersheds.</p>
<p>I brought this up with our engineer, who after some research, informed me of the multitude of rulesets used by various zonal statistics tools and their underlying code used for calculations. I was embarassed to admit that I never put much thought into <em>how</em> the raster cells were being assigned to each sub-basin or even considered that various methods might produce radically different results. Although, as a result of our collective concern, our engineer began development on <code>exactextract</code>. In this tutorial we will outline comparative accuracy and speed of a variety of widely used zonal statistics calculators and the recently developed <code>exactextractr</code> package.</p>
</div>
</div>
<div id="methods" class="section level1">
<h1><span class="header-section-number">2</span> Methods</h1>
<div id="loading-the-packages" class="section level2">
<h2><span class="header-section-number">2.1</span> Loading the Packages</h2>
<p>For this tutorial we will demonstrate comparative accuracy and computational times for zonal statistics tools provided by QGIS, R’s <code>raster</code> and <code>velox</code> packages, and <code>exactextract</code>. Additionally, we’ll be using <code>sf</code> <span class="citation">(Pebesma <a href="#ref-Pebesma2018">2018</a>)</span> to manage our vector boundaries. You can install the <code>raster</code>, <code>velox</code>, <code>sf</code>, <code>exactextractr</code> are all available on CRAN.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb1-1" data-line-number="1"><span class="kw">library</span>(devtools)</a>
<a class="sourceLine" id="cb1-2" data-line-number="2"><span class="kw">library</span>(raster)</a>
<a class="sourceLine" id="cb1-3" data-line-number="3"><span class="kw">library</span>(velox)</a>
<a class="sourceLine" id="cb1-4" data-line-number="4"><span class="kw">library</span>(sf)</a>
<a class="sourceLine" id="cb1-5" data-line-number="5"><span class="kw">library</span>(data.table)</a></code></pre></div>
<p>Now install and load <em>exactextractr</em> with the following commands.</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb2-1" data-line-number="1"><span class="kw">library</span>(exactextractr)</a></code></pre></div>
</div>
<div id="getting-the-data" class="section level2">
<h2><span class="header-section-number">2.2</span> Getting the Data</h2>
<p>Although the complex and meandering boundaries of river basins accentuates disparity between methods, for this vignette we’ll use GADM political boundaries <span class="citation">(University of California, Berkley <a href="#ref-UniversityofCaliforniaBerkley2018">2018</a>)</span> of Brazil for our polygon overlay; GADM is easily accessible with the raster package. For the raster data we will use The Standardized Precipitation-Evapotranspiration Index (SPEI; <span class="citation">(Vicente-Serrano, Beguería, and López-Moreno <a href="#ref-Vicente-Serrano2009">2009</a>)</span>). Create two <code>sf</code> objects of Brazil: 1) a simple polygon of the entire country, and 2) a complex polygon with level 1 administrative boundaries.</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb3-1" data-line-number="1">brazil0 &lt;-<span class="st"> </span>sf<span class="op">::</span><span class="kw">st_as_sf</span>(<span class="kw">getData</span>(<span class="st">&#39;GADM&#39;</span>, <span class="dt">country=</span><span class="st">&#39;BRA&#39;</span>, <span class="dt">level=</span><span class="dv">0</span>))</a>
<a class="sourceLine" id="cb3-2" data-line-number="2">brazil1 &lt;-<span class="st"> </span>sf<span class="op">::</span><span class="kw">st_as_sf</span>(<span class="kw">getData</span>(<span class="st">&#39;GADM&#39;</span>, <span class="dt">country=</span><span class="st">&#39;BRA&#39;</span>, <span class="dt">level=</span><span class="dv">1</span>))</a></code></pre></div>
<p>The default plotting function of sf will create a multiplot with a separate figure for each attribute, which can be slow with complex poygons and uninformitive with redundant column attributes. We can quickly check the data by setting the plot limit (<code>max.plot=1</code>), indexing a specific attribute (<code>brazil1[&quot;NAME_1&quot;]</code>), or specifying only the geometries (<code>st_geometry(brazil1)</code>). We’ll check the boundaries plotting only the geometries. For more information on using the <code>sf</code> package refer to several fantastic vignettes on their <a href="https://github.com/r-spatial/sf">GitHub page</a>.</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb4-1" data-line-number="1"><span class="kw">plot</span>(sf<span class="op">::</span><span class="kw">st_geometry</span>(brazil1), <span class="dt">axes =</span> <span class="ot">TRUE</span>, <span class="dt">main =</span> <span class="st">&quot;Brazilian States&quot;</span>)</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-5-1.svg" width="672" /></p>
<!-- SPEI data are available as Network Common Data Form (NetCDF) at a global extent for integration periods between 1 and 48 months. Files are differentiated by their integration period, but each period file includes annual data for 1950--2019. NetCDF files can be daunting, because they can contain data for several years and several variables in a single file. For this tutorial we will simply acquire the file and extract the singular data point of interest. For more information on using NetCDF files with R with the *ncdf4* package [@Pierce2019] refer to the package [documentation](https://cran.r-project.org/web/packages/ncdf4/index.html). The following code chunk will directly download SPEI data for a 12 month integration period and save it to your working directory. The file is quite large so it's wrapped in an `if()` statement to check if the file already exists in your working directory. After the file is downloaded we can read in a single time-step using the raster package by specifying month 829 (January, 2019) and the variable of interest (spei). We can verify the raster data looks satisfactory with a quick base R plotting function. -->
<p>Similarly, we can acquire the precipitation data directly from NOAA’s Climate Prediction Center via their FTP service. Precipiation data is provided in mm / cell, however, because cells sizes do not have fixed areas (i.e. they are smaller towards the equator) we multiply the precipitation values by the area of the cell. Lastly, we’ll divide the results by 1,000 to convert the total to cubic meters and plot the raster in base R for a visual check before we move forward.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb5-1" data-line-number="1"><span class="cf">if</span>(<span class="op">!</span><span class="kw">file.exists</span>(<span class="st">&quot;precip_tot_0319.tif&quot;</span>)){</a>
<a class="sourceLine" id="cb5-2" data-line-number="2"><span class="kw">download.file</span>(<span class="st">&quot;ftp://ftp.cpc.ncep.noaa.gov/GIS/GRADS_GIS/GeoTIFF/GLB_DLY_PREC/STATISTICS/MONTHLY/p_glb_total_201903_float.tif&quot;</span>, <span class="dt">destfile =</span> <span class="st">&quot;precip_tot_0319.tif&quot;</span>, <span class="dt">method =</span> <span class="st">&#39;libcurl&#39;</span>)}</a>
<a class="sourceLine" id="cb5-3" data-line-number="3"></a>
<a class="sourceLine" id="cb5-4" data-line-number="4">precip&lt;-raster<span class="op">::</span><span class="kw">raster</span>(<span class="st">&quot;precip_tot_0319.tif&quot;</span>)</a>
<a class="sourceLine" id="cb5-5" data-line-number="5">precip[precip<span class="op">&lt;</span><span class="dv">0</span>]&lt;-<span class="dv">0</span></a>
<a class="sourceLine" id="cb5-6" data-line-number="6">precip&lt;-(precip<span class="op">*</span><span class="kw">area</span>(precip)<span class="op">/</span><span class="dv">1000</span>)</a>
<a class="sourceLine" id="cb5-7" data-line-number="7"><span class="kw">plot</span>(precip, <span class="dt">main =</span> <span class="st">&quot;Cumulative Rainfall for March, 2019&quot;</span>)</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-7-1.svg" width="672" /></p>
</div>
<div id="the-extractions" class="section level2">
<h2><span class="header-section-number">2.3</span> The Extractions</h2>
<p>We’ll begin by performning zonal sum statistics using the entire country with each of the packages in question.</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb6-1" data-line-number="1">start.time &lt;-<span class="st"> </span><span class="kw">proc.time</span>()</a>
<a class="sourceLine" id="cb6-2" data-line-number="2">brazil0.sum.raster &lt;-raster<span class="op">::</span><span class="kw">extract</span>(precip, brazil0, <span class="dt">fun=</span>sum, <span class="dt">na.rm=</span><span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb6-3" data-line-number="3">elapsed.raster &lt;-<span class="st"> </span><span class="kw">proc.time</span>() <span class="op">-</span><span class="st"> </span>start.time</a></code></pre></div>
<p>When using the <code>velox</code> package you must convert raster objects to velox objects first. <code>velox</code> also employs some unusual syntax for manipulations and processing.</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb7-1" data-line-number="1">precip.vx &lt;-<span class="kw">velox</span>(precip)</a>
<a class="sourceLine" id="cb7-2" data-line-number="2">start.time &lt;-<span class="st"> </span><span class="kw">proc.time</span>()</a>
<a class="sourceLine" id="cb7-3" data-line-number="3">brazil0.sum.velox &lt;-<span class="st"> </span>precip.vx<span class="op">$</span><span class="kw">extract</span>(<span class="dt">sp=</span>brazil0, <span class="dt">fun=</span><span class="cf">function</span> (x){<span class="kw">sum</span>(x, <span class="dt">na.rm=</span><span class="ot">TRUE</span>)})</a>
<a class="sourceLine" id="cb7-4" data-line-number="4">elapsed.velox &lt;-<span class="st"> </span><span class="kw">proc.time</span>() <span class="op">-</span><span class="st"> </span>start.time</a></code></pre></div>
<p>And now using <code>exactextractr</code>.</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb8-1" data-line-number="1">start.time &lt;-<span class="st"> </span><span class="kw">proc.time</span>()</a>
<a class="sourceLine" id="cb8-2" data-line-number="2">brazil0.sum.exex &lt;-<span class="st"> </span>exactextractr<span class="op">::</span><span class="kw">exact_extract</span>(precip, brazil0, <span class="st">&#39;sum&#39;</span>)</a>
<a class="sourceLine" id="cb8-3" data-line-number="3">elapsed.exex &lt;-<span class="st"> </span><span class="kw">proc.time</span>() <span class="op">-</span><span class="st"> </span>start.time</a></code></pre></div>
<p>We can build a data frame to compare the results.</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb9-1" data-line-number="1">packages &lt;-<span class="st"> </span><span class="kw">c</span>(<span class="st">&#39;raster&#39;</span>,<span class="st">&#39;velox&#39;</span>,<span class="st">&#39;exactextractr&#39;</span>)</a>
<a class="sourceLine" id="cb9-2" data-line-number="2">times&lt;-<span class="st"> </span><span class="kw">round</span>(<span class="kw">c</span>(<span class="kw">as.numeric</span>(elapsed.raster[<span class="dv">3</span>]),<span class="kw">as.numeric</span>(elapsed.velox[<span class="dv">3</span>]),<span class="kw">as.numeric</span>(elapsed.exex[<span class="dv">3</span>])), <span class="dt">digits=</span><span class="dv">2</span>)</a>
<a class="sourceLine" id="cb9-3" data-line-number="3">sums&lt;-<span class="st"> </span><span class="kw">round</span>(<span class="kw">c</span>(brazil0.sum.raster,brazil0.sum.velox,brazil0.sum.exex), <span class="dt">digits =</span> <span class="dv">0</span>)</a>
<a class="sourceLine" id="cb9-4" data-line-number="4">summary.brazil0 &lt;-<span class="kw">data.frame</span>(<span class="kw">cbind</span>(packages, times, sums))</a></code></pre></div>
<table class="table" style="width: auto !important; margin-left: auto; margin-right: auto;">
<caption>
Table 1: Comparative processing time and aggregated precipitaion sums for the entirety of Brazil (ADM0).
</caption>
<thead>
<tr>
<th style="text-align:left;">
Package
</th>
<th style="text-align:center;">
Time ADM0
</th>
<th style="text-align:center;">
Sum Precip ADM0
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
raster
</td>
<td style="text-align:center;">
26.84
</td>
<td style="text-align:center;">
1574433
</td>
</tr>
<tr>
<td style="text-align:left;">
velox
</td>
<td style="text-align:center;">
3.58
</td>
<td style="text-align:center;">
1574433
</td>
</tr>
<tr>
<td style="text-align:left;">
exactextractr
</td>
<td style="text-align:center;">
0.41
</td>
<td style="text-align:center;">
1574767
</td>
</tr>
</tbody>
</table>
<p>Now let’s repeat these operations using states and re-aggregate the totals back to the country level. This will highlight the accuracy errors inherent to re-aggregating zonal statistics using the <code>raster</code> and <code>velox</code> packages. We can make this a bit easier by wrapping this up into a function.</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb10-1" data-line-number="1">zonalComp&lt;-<span class="cf">function</span>(shapefile, raster, <span class="dt">adm_level=</span><span class="dv">0</span>){</a>
<a class="sourceLine" id="cb10-2" data-line-number="2">  </a>
<a class="sourceLine" id="cb10-3" data-line-number="3">  <span class="cf">if</span>(adm_level<span class="op">==</span><span class="dv">0</span>){poly.names&lt;-shapefile<span class="op">$</span>NAME_<span class="dv">0</span>}</a>
<a class="sourceLine" id="cb10-4" data-line-number="4">  <span class="cf">if</span>(adm_level<span class="op">==</span><span class="dv">1</span>){poly.names&lt;-shapefile<span class="op">$</span>NAME_<span class="dv">1</span>}</a>
<a class="sourceLine" id="cb10-5" data-line-number="5">  <span class="cf">if</span>(adm_level<span class="op">==</span><span class="dv">2</span>){poly.names&lt;-shapefile<span class="op">$</span>NAME_<span class="dv">2</span>}</a>
<a class="sourceLine" id="cb10-6" data-line-number="6">  </a>
<a class="sourceLine" id="cb10-7" data-line-number="7">start.time &lt;-<span class="st"> </span><span class="kw">proc.time</span>()</a>
<a class="sourceLine" id="cb10-8" data-line-number="8">zonal.raster &lt;-raster<span class="op">::</span><span class="kw">extract</span>(raster, shapefile, <span class="dt">fun=</span>sum, <span class="dt">na.rm=</span><span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb10-9" data-line-number="9">elapsed.raster &lt;-<span class="st"> </span><span class="kw">proc.time</span>() <span class="op">-</span><span class="st"> </span>start.time</a>
<a class="sourceLine" id="cb10-10" data-line-number="10"></a>
<a class="sourceLine" id="cb10-11" data-line-number="11">precip.vx &lt;-<span class="kw">velox</span>(raster)</a>
<a class="sourceLine" id="cb10-12" data-line-number="12">start.time &lt;-<span class="st"> </span><span class="kw">proc.time</span>()</a>
<a class="sourceLine" id="cb10-13" data-line-number="13">zonal.velox &lt;-<span class="st"> </span>precip.vx<span class="op">$</span><span class="kw">extract</span>(<span class="dt">sp=</span>shapefile, </a>
<a class="sourceLine" id="cb10-14" data-line-number="14">                                 <span class="dt">fun=</span><span class="cf">function</span> (x){<span class="kw">sum</span>(x, <span class="dt">na.rm=</span><span class="ot">TRUE</span>)}, </a>
<a class="sourceLine" id="cb10-15" data-line-number="15">                                 <span class="dt">small =</span> <span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb10-16" data-line-number="16"></a>
<a class="sourceLine" id="cb10-17" data-line-number="17">elapsed.velox &lt;-<span class="st"> </span><span class="kw">proc.time</span>() <span class="op">-</span><span class="st"> </span>start.time</a>
<a class="sourceLine" id="cb10-18" data-line-number="18"></a>
<a class="sourceLine" id="cb10-19" data-line-number="19">start.time &lt;-<span class="st"> </span><span class="kw">proc.time</span>()</a>
<a class="sourceLine" id="cb10-20" data-line-number="20">zonal.exex &lt;-<span class="st"> </span>exactextractr<span class="op">::</span><span class="kw">exact_extract</span>(raster, shapefile, <span class="st">&#39;sum&#39;</span>)</a>
<a class="sourceLine" id="cb10-21" data-line-number="21">elapsed.exex &lt;-<span class="st"> </span><span class="kw">proc.time</span>() <span class="op">-</span><span class="st"> </span>start.time</a>
<a class="sourceLine" id="cb10-22" data-line-number="22"></a>
<a class="sourceLine" id="cb10-23" data-line-number="23">packages&lt;-<span class="kw">c</span>(<span class="st">&#39;raster&#39;</span>,<span class="st">&#39;velox&#39;</span>,<span class="st">&#39;exactextractr&#39;</span>)</a>
<a class="sourceLine" id="cb10-24" data-line-number="24">vertices&lt;-<span class="kw">nrow</span>(<span class="kw">st_coordinates</span>(shapefile))</a>
<a class="sourceLine" id="cb10-25" data-line-number="25">resolution&lt;-raster<span class="op">::</span><span class="kw">res</span>(raster)[<span class="dv">1</span>]</a>
<a class="sourceLine" id="cb10-26" data-line-number="26">times&lt;-<span class="kw">round</span>(<span class="kw">c</span>(<span class="kw">as.numeric</span>(elapsed.raster[<span class="dv">3</span>]),</a>
<a class="sourceLine" id="cb10-27" data-line-number="27">               <span class="kw">as.numeric</span>(elapsed.velox[<span class="dv">3</span>]),</a>
<a class="sourceLine" id="cb10-28" data-line-number="28">               <span class="kw">as.numeric</span>(elapsed.exex[<span class="dv">3</span>])), <span class="dt">digits=</span><span class="dv">2</span>)</a>
<a class="sourceLine" id="cb10-29" data-line-number="29">zonals&lt;-<span class="kw">c</span>(<span class="kw">sum</span>(zonal.raster), <span class="kw">sum</span>(zonal.velox), <span class="kw">sum</span>(zonal.exex))</a>
<a class="sourceLine" id="cb10-30" data-line-number="30"></a>
<a class="sourceLine" id="cb10-31" data-line-number="31">summary.times&lt;-<span class="kw">data.frame</span>(<span class="dt">packages=</span>packages,</a>
<a class="sourceLine" id="cb10-32" data-line-number="32">                          <span class="dt">vertices=</span>vertices,</a>
<a class="sourceLine" id="cb10-33" data-line-number="33">                          <span class="dt">resolution=</span>resolution,</a>
<a class="sourceLine" id="cb10-34" data-line-number="34">                          <span class="dt">times=</span>times,</a>
<a class="sourceLine" id="cb10-35" data-line-number="35">                          <span class="dt">zonals=</span>zonals)</a>
<a class="sourceLine" id="cb10-36" data-line-number="36"></a>
<a class="sourceLine" id="cb10-37" data-line-number="37">summary.zonals&lt;-<span class="kw">data.frame</span>(<span class="dt">name=</span>poly.names,</a>
<a class="sourceLine" id="cb10-38" data-line-number="38">                        <span class="dt">raster=</span><span class="kw">round</span>(zonal.raster, <span class="dt">digits=</span><span class="dv">0</span>),</a>
<a class="sourceLine" id="cb10-39" data-line-number="39">                        <span class="dt">velox=</span><span class="kw">round</span>(zonal.velox, <span class="dt">digits=</span><span class="dv">0</span>),</a>
<a class="sourceLine" id="cb10-40" data-line-number="40">                        <span class="dt">exactextractr=</span><span class="kw">round</span>(zonal.exex, <span class="dt">digits=</span><span class="dv">0</span>))</a>
<a class="sourceLine" id="cb10-41" data-line-number="41">summary.zonals<span class="op">$</span>diff&lt;-summary.zonals<span class="op">$</span>exactextractr<span class="op">-</span>summary.zonals<span class="op">$</span>raster</a>
<a class="sourceLine" id="cb10-42" data-line-number="42">summary.zonals<span class="op">$</span>diff_per&lt;-summary.zonals<span class="op">$</span>diff<span class="op">/</span>summary.zonals<span class="op">$</span>raster</a>
<a class="sourceLine" id="cb10-43" data-line-number="43">summary.zonals<span class="op">$</span>diff_per&lt;-<span class="kw">round</span>(<span class="kw">abs</span>(summary.zonals<span class="op">$</span>diff_per<span class="op">*</span><span class="dv">100</span>), <span class="dt">digits=</span><span class="dv">0</span>)</a>
<a class="sourceLine" id="cb10-44" data-line-number="44"></a>
<a class="sourceLine" id="cb10-45" data-line-number="45">benchmarks&lt;-<span class="kw">list</span>(summary.times,summary.zonals)</a>
<a class="sourceLine" id="cb10-46" data-line-number="46"></a>
<a class="sourceLine" id="cb10-47" data-line-number="47"><span class="kw">names</span>(benchmarks)[[<span class="dv">1</span>]]&lt;-<span class="st">&quot;time&quot;</span></a>
<a class="sourceLine" id="cb10-48" data-line-number="48"><span class="kw">names</span>(benchmarks)[[<span class="dv">2</span>]]&lt;-<span class="st">&quot;zonals&quot;</span></a>
<a class="sourceLine" id="cb10-49" data-line-number="49"></a>
<a class="sourceLine" id="cb10-50" data-line-number="50"><span class="kw">return</span>(benchmarks)</a>
<a class="sourceLine" id="cb10-51" data-line-number="51">}</a></code></pre></div>
<div class="sourceCode" id="cb11"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb11-1" data-line-number="1">brazil1.out&lt;-<span class="kw">zonalComp</span>(<span class="dt">shapefile=</span>brazil1, <span class="dt">raster=</span>precip, <span class="dt">adm_level =</span> <span class="dv">1</span>)</a></code></pre></div>
<p>We can build a data frame to compare the results from the different admin levels.</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb12-1" data-line-number="1">summary.adm0.adm1 &lt;-<span class="kw">data.frame</span>(<span class="kw">cbind</span>(packages, </a>
<a class="sourceLine" id="cb12-2" data-line-number="2">                                     times, </a>
<a class="sourceLine" id="cb12-3" data-line-number="3">                                     brazil1.out<span class="op">$</span>time<span class="op">$</span>times, </a>
<a class="sourceLine" id="cb12-4" data-line-number="4">                                     sums, </a>
<a class="sourceLine" id="cb12-5" data-line-number="5">                                     <span class="kw">round</span>(brazil1.out<span class="op">$</span>time<span class="op">$</span>zonals, <span class="dt">digits=</span><span class="dv">0</span>)))</a></code></pre></div>
<table class="table" style="width: auto !important; margin-left: auto; margin-right: auto;">
<caption>
Table 2: Comparative processing time and aggregated precipitaion sums for the entirety of Brazil (ADM0) and Brazilian states (ADM1).
</caption>
<thead>
<tr>
<th style="text-align:left;">
Package
</th>
<th style="text-align:center;">
Time ADM0
</th>
<th style="text-align:center;">
Time ADM1
</th>
<th style="text-align:center;">
Sum Precip ADM0
</th>
<th style="text-align:center;">
Sum Precip ADM1
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
raster
</td>
<td style="text-align:center;">
26.84
</td>
<td style="text-align:center;">
4.57
</td>
<td style="text-align:center;">
1574433
</td>
<td style="text-align:center;">
1574433
</td>
</tr>
<tr>
<td style="text-align:left;">
velox
</td>
<td style="text-align:center;">
3.58
</td>
<td style="text-align:center;">
0.19
</td>
<td style="text-align:center;">
1574433
</td>
<td style="text-align:center;">
1574433
</td>
</tr>
<tr>
<td style="text-align:left;">
exactextractr
</td>
<td style="text-align:center;">
0.41
</td>
<td style="text-align:center;">
0.49
</td>
<td style="text-align:center;">
1574767
</td>
<td style="text-align:center;">
1574767
</td>
</tr>
</tbody>
</table>
<p>Although there are significant differences in processing time, the aggregated sums only differ by 300 cubic meters and the comparative administrative units do not vary. This can be explained by a couple factors. First, the precipitation data in this region has a low variance as nearly all cells exhibit high rainfaill Second, Brasilian states are fairly large relative to the raster cell size. We can examine a comparative choropleth of our results at the state level to highlight some of the lower level differences.</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb13-1" data-line-number="1">brazil1&lt;-<span class="kw">merge</span>(brazil1,brazil1.out<span class="op">$</span>zonals, <span class="dt">by.x=</span><span class="st">&#39;NAME_1&#39;</span>, <span class="dt">by.y=</span><span class="st">&#39;name&#39;</span>)</a></code></pre></div>
<div class="sourceCode" id="cb14"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb14-1" data-line-number="1"><span class="kw">plot</span>(brazil1[<span class="kw">c</span>(<span class="st">&#39;diff&#39;</span>)], <span class="dt">lwd=</span><span class="fl">0.000001</span>, <span class="dt">main=</span><span class="st">&quot;Absolute Difference&quot;</span>)</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-18-1.svg" width="672" /></p>
<div class="sourceCode" id="cb15"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb15-1" data-line-number="1"><span class="kw">plot</span>(brazil1[<span class="kw">c</span>(<span class="st">&#39;diff_per&#39;</span>)], <span class="dt">lwd=</span><span class="fl">0.000001</span>, <span class="dt">main=</span><span class="st">&quot;Percent Difference&quot;</span>)</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-18-2.svg" width="672" /></p>
<p>Estimates at the state level differ by as much as ± 1,800 cubic meters. Interior states, and states with simplified boundaries have the smallest differences, whereas states constituting the perimeter of the country and those with complex boundaries exhibit the greatest differences.</p>
</div>
<div id="increasing-the-variance" class="section level2">
<h2><span class="header-section-number">2.4</span> Increasing the Variance</h2>
<p>Differences in zonal statistic accuracy are exacerbated by raster data with courser resolutions or higher variance, and vector data with more complex boundaries and multi-polygonal structure. Let’s work through a second example with China’s 2nd administrative units (prefectures) and <a href="http://mapspam.info/data/">IFPRI MapSPAM</a> total rice production. MapSPAM is the best available global cropping data. It is available for 42 crops, 4 different cropping systems, and presented as 4 different metrics (production, yield, physical area, harvested area, and value of production). Due to the nature of agricultural systems most the raster layers have strong patchiness and can be highly variable even between neighboring cells. Lets’s start by acquiring the data and making quick visual checks.</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb16-1" data-line-number="1">china2 &lt;-<span class="st"> </span>sf<span class="op">::</span><span class="kw">st_as_sf</span>(<span class="kw">getData</span>(<span class="st">&#39;GADM&#39;</span>, <span class="dt">country=</span><span class="st">&#39;CHN&#39;</span>, <span class="dt">level=</span><span class="dv">2</span>))</a>
<a class="sourceLine" id="cb16-2" data-line-number="2">rice&lt;-raster<span class="op">::</span><span class="kw">raster</span>(<span class="st">&#39;spam2010v1r0_global_production_rice_a.tif&#39;</span>)</a></code></pre></div>
<div class="sourceCode" id="cb17"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb17-1" data-line-number="1"><span class="kw">plot</span>(sf<span class="op">::</span><span class="kw">st_geometry</span>(china2), <span class="dt">axes =</span> <span class="ot">TRUE</span>, <span class="dt">main =</span> <span class="st">&quot;Chinese Prefectures&quot;</span>)</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-20-1.svg" width="672" /></p>
<div class="sourceCode" id="cb18"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb18-1" data-line-number="1"><span class="kw">plot</span>(rice, <span class="dt">main=</span><span class="st">&quot;Global Rice Production&quot;</span>)</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-21-1.svg" width="672" /></p>
<p>The cropping data is much more variable and China’s prefectures are mostly small in size with complex perimeters. We’ll use our function to prepare our zonal sums.</p>
<div class="sourceCode" id="cb19"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb19-1" data-line-number="1">china.rice&lt;-<span class="kw">zonalComp</span>(<span class="dt">shapefile=</span>china2, <span class="dt">raster=</span>rice, <span class="dt">adm_level =</span> <span class="dv">2</span>)</a></code></pre></div>
<table class="table" style="width: auto !important; margin-left: auto; margin-right: auto;">
<caption>
Table 3: Comparative processing time and aggregated rice production sums for Chinese prefectures.
</caption>
<thead>
<tr>
<th style="text-align:left;">
Package
</th>
<th style="text-align:center;">
Vertices
</th>
<th style="text-align:center;">
Resolution
</th>
<th style="text-align:center;">
Times
</th>
<th style="text-align:center;">
Rice Production
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
raster
</td>
<td style="text-align:center;">
1,183,671
</td>
<td style="text-align:center;">
0.083
</td>
<td style="text-align:center;">
163.60
</td>
<td style="text-align:center;">
197,419,671
</td>
</tr>
<tr>
<td style="text-align:left;">
velox
</td>
<td style="text-align:center;">
1,183,671
</td>
<td style="text-align:center;">
0.083
</td>
<td style="text-align:center;">
2.20
</td>
<td style="text-align:center;">
197,419,671
</td>
</tr>
<tr>
<td style="text-align:left;">
exactextractr
</td>
<td style="text-align:center;">
1,183,671
</td>
<td style="text-align:center;">
0.083
</td>
<td style="text-align:center;">
1.23
</td>
<td style="text-align:center;">
197,263,870
</td>
</tr>
</tbody>
</table>
<p>Similar to our previous example, the <code>raster</code> package took substantially more time than both <code>velox</code> and <code>exactextractr</code>. The aggregated differences are modest, but still total more than 150,000 tonnes of rice. Let’s take a look at prefecture level differences with a choropleth.</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb20-1" data-line-number="1">china2&lt;-<span class="kw">merge</span>(china2,china.rice<span class="op">$</span>zonals, <span class="dt">by.x=</span><span class="st">&#39;NAME_2&#39;</span>, <span class="dt">by.y=</span><span class="st">&#39;name&#39;</span>)</a>
<a class="sourceLine" id="cb20-2" data-line-number="2"><span class="co"># plot(brazil1[c(&#39;diff&#39;,&#39;diff_per&#39;)], </span></a>
<a class="sourceLine" id="cb20-3" data-line-number="3"><span class="co">#      key.pos=1, key.length=1, lwd=0.000001)</span></a></code></pre></div>
<div class="sourceCode" id="cb21"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb21-1" data-line-number="1"><span class="kw">plot</span>(china2[<span class="kw">c</span>(<span class="st">&#39;diff&#39;</span>)], </a>
<a class="sourceLine" id="cb21-2" data-line-number="2">     <span class="dt">lwd=</span><span class="fl">0.000001</span>, </a>
<a class="sourceLine" id="cb21-3" data-line-number="3">     <span class="dt">main=</span><span class="st">&quot;Difference in Estimated Rice Production&quot;</span>,</a>
<a class="sourceLine" id="cb21-4" data-line-number="4">     <span class="dt">breaks=</span><span class="kw">seq</span>(<span class="op">-</span><span class="dv">100000</span>,<span class="dv">100000</span>,<span class="dv">20000</span>))</a></code></pre></div>
<p><img src="exact_extract_comp_files/figure-html/unnamed-chunk-25-1.svg" width="672" /></p>
<p>The differences are more stark with these datasets. Rice production estimates from <code>exactextractr</code> vary ± 100,000 tonnes compared to <code>raster</code> and <code>velox</code> calculations. Due to a variety of <code>Inf</code> values, <code>NaN</code> values, and percent differences greater than 1,000, we won’t produce a choropleth or histogram of the percent change in methodologies, however, if you examine <code>china.rice$zonals</code> there are 17 prefectures where <code>raster</code> estimated 0 production, but <code>exactextractr</code> showed as much as 7,171 tonnes, and more than 100 prefectures with differences between 6 - 83,000%.</p>
</div>
</div>
<div id="conclusions" class="section level1">
<h1><span class="header-section-number">3</span> Conclusions</h1>
<p>We successfully demonstrated that <code>exactextractr</code> performs 5-160 times faster than competing and widely employed zonal statistics methodologies in the R universe. In addition to processing gains, <code>exactextractr</code> improves accuracy using zonal sums by approximately 1-5% on average, and routinely by 20%. While these examples are by no means exhaustive, they are common applications with popular raster and vector data sets. Further explorations of comparative performance should address comparative estimates as a function of simulated raster datasets while systematically controlling cell variance, patch size, and patch distribution using mutliple summary statistcs.</p>
</div>
<div id="references" class="section level1 unnumbered">
<h1>References</h1>
<div id="refs" class="references">
<div id="ref-IFPRI2019">
<p>IFPRI. 2019. “Global Spatially-Disaggregated Crop Production Statistics Data for 2010 Version 1.0.” International Food Policy Research Institute. <a href="https://dataverse.harvard.edu/dataset.xhtml?persistentId=doi:10.7910/DVN/PRFF8V">https://dataverse.harvard.edu/dataset.xhtml?persistentId=doi:10.7910/DVN/PRFF8V</a>.</p>
</div>
<div id="ref-Lehner2013">
<p>Lehner, Bernhard, and Günther Grill. 2013. “Global River Hydrography and Network Routing: Baseline Data and New Approaches to Study the World’s Large River Systems.” <em>Hydrological Processes</em> 27 (15): 2171–86. <a href="https://doi.org/10.1002/hyp.9740">https://doi.org/10.1002/hyp.9740</a>.</p>
</div>
<div id="ref-Martin2012b">
<p>Martin, Laura J., Bernd Blossey, and Erle Ellis. 2012. “Mapping Where Ecologists Work: Biases in the Global Distribution of Terrestrial Ecological Observations.” <em>Frontiers in Ecology and the Environment</em> 10 (4): 195–201. <a href="https://doi.org/10.1890/110154">https://doi.org/10.1890/110154</a>.</p>
</div>
<div id="ref-Pebesma2018">
<p>Pebesma, Edzer. 2018. <em>Sf: Simple Features for R</em>. <a href="https://cran.r-project.org/package=sf">https://cran.r-project.org/package=sf</a>.</p>
</div>
<div id="ref-Saadat2011">
<p>Saadat, Hossein, Jan Adamowski, Robert Bonnell, Forood Sharifi, Mohammad Namdar, and Sasan Ale-Ebrahim. 2011. “Land Use and Land Cover Classification over a Large Area in Iran Based on Single Date Analysis of Satellite Imagery.” <em>ISPRS Journal of Photogrammetry and Remote Sensing</em> 66 (5): 608–19. <a href="https://doi.org/10.1016/j.isprsjprs.2011.04.001">https://doi.org/10.1016/j.isprsjprs.2011.04.001</a>.</p>
</div>
<div id="ref-Segan2011">
<p>Segan, Daniel B., Edward T. Game, Matthew E. Watts, Romola R. Stewart, and Hugh P. Possingham. 2011. “An Interoperable Decision Support Tool for Conservation Planning.” <em>Environmental Modelling &amp; Software</em> 26 (12): 1434–41. <a href="https://doi.org/10.1016/j.envsoft.2011.08.002">https://doi.org/10.1016/j.envsoft.2011.08.002</a>.</p>
</div>
<div id="ref-Sobota2015">
<p>Sobota, Daniel J., Jana E. Compton, Michelle L. McCrackin, and Shweta Singh. 2015. “Cost of Reactive Nitrogen Release from Human Activities to the Environment in the United States.” <em>Environmental Research Letters</em> 10 (2): 025006. <a href="https://doi.org/10.1088/1748-9326/10/2/025006">https://doi.org/10.1088/1748-9326/10/2/025006</a>.</p>
</div>
<div id="ref-UniversityofCaliforniaBerkley2018">
<p>University of California, Berkley. 2018. “Global Administrative Areas Version 3.6.” Dataset. <a href="www.gadm.org">www.gadm.org</a>.</p>
</div>
<div id="ref-Vicente-Serrano2009">
<p>Vicente-Serrano, Sergio M., Santiago Beguería, and Juan I. López-Moreno. 2009. “A Multiscalar Drought Index Sensitive to Global Warming: The Standardized Precipitation Evapotranspiration Index.” <em>Journal of Climate</em> 23 (7): 1696–1718. <a href="https://doi.org/10.1175/2009JCLI2909.1">https://doi.org/10.1175/2009JCLI2909.1</a>.</p>
</div>
</div>
</div>

<footer>

<h1> Additional Meta-Data </h1>

<div id="related-packages-block">
<h3> Related Packages: </h3>
<ul>
<li>exactextractr</li>
<li>raster</li>
<li>velox</li>
</ul>
</div>

<div id="related-datasets-block">
<h3> Related Data Sets: </h3>
<ul>
<li>NOAA’s Climate Prediction Center Global Monthly Precipitation</li>
<li>International Food Policy Research Instistute’s Global Spatially Disaggregated Crop Production Statistics Data for 2010 Version 1.0 (IFPRI MapSPAM)</li>
<li>Global Administrative Areas Version 3.6 (GADM)</li>
</ul>
</div>

<div id="data-presentation-forms-block">
<h3> Data Categories:</h3>
<span id="data-presentation-forms">raster, polygons</span>
</div>

<div id="related-vignettes-block">
<h3> Related Vignettes: </h3>
<ul>
<li>Zonal Statistic benchmarking with exactextractr, raster, and velox packages.</li>
</ul>
</div>

</footer>

</body>

</html>
